﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace cv11
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            TextBox_Events.Clear();
        }

        #region Direct Event
        //Nepostupuje dale, je podobny jako klasicka udalost

        private void Rectangle_MouseEnter(object sender, MouseEventArgs e)
        {
            TextBox_Events.AppendText(nameof(Rectangle_MouseEnter) + Environment.NewLine);
        }

        private void Grid_MouseEnter(object sender, MouseEventArgs e)
        {
            TextBox_Events.AppendText(nameof(Grid_MouseEnter) + Environment.NewLine);
        }

        #endregion

        #region Bubbling Event
        //Postupuje dale vizualnim stromem nahodu (ke koreni).

        private void Rectangle_MouseDown(object sender, MouseButtonEventArgs e)
        {
            TextBox_Events.AppendText(nameof(Rectangle_MouseDown) + Environment.NewLine);
            //Nastavenim vlastnosti Handeled na true se probublavani zastavi.
            //e.Handled = true;
        }

        private void Grid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            TextBox_Events.AppendText(nameof(Grid_MouseDown) + Environment.NewLine);
        }

        #endregion

        #region Tunneling Event
        //Postupuje dale vizualnim stromem dolu (k listum).

        private void Rectangle_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            TextBox_Events.AppendText(nameof(Rectangle_PreviewMouseDown) + Environment.NewLine);
        }

        private void Grid_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            TextBox_Events.AppendText(nameof(Grid_PreviewMouseDown) + Environment.NewLine);
            //Nastavenim vlastnosti Handeled na true se tunelovani zastavi.
            //e.Handled = true;
        }

        #endregion
    }
}
